//@Author: Martin Laak.  http://www.arvutilaat.net/D/    Kasutage seda koodi nagu tahate, ainult jtke alles viide minu nimele ja lehele. Use this code however you like, but keep the reference to my name and page,   
//Tmbab html lehe koos piltidega ning pakib need kik zip faili.

import std.file;
import std.stream;
import std.socket;
import std.socketstream;
import std.conv; //toInt(char []);
import std.zip;

TcpSocket soc;  //Socket, mida jrgnev stream hakkab kasutama
SocketStream ss;//Stream, lbi mille serveriga suheldakse
ZipArchive ZA;//Zip arhiiv, kuhu failid pannakse


int OLEMAS[char []];//Mis failid on juba allalaetud? See vlistab topeltlaadimise



char []server(char []s){ //Eraldab stringist serveri osa, niteks http://ww.neti.ee/pages/3.htm >>> www.neti.ee
 if(s[0..7]=="http://")s=s[7..s.length];
 for(int x=0;x<s.length;x++){
   if(s[x]=='/'){
     return s[0..x];
   }
 }
 return s;
}


char []fail(char []s){ //Eraldab stringist faili osa, niteks http://ww.neti.ee/pages/3.htm >>> pages/3.htm
 if(s[0..7]=="http://")s=s[7..s.length];
 for(int x=0;x<s.length;x++){
   if(s[x]=='/'){
     if(x==s.length)return "/";
     return s[x..s.length];
   }
 }
 return "/";
}


ubyte[] tomba(char []mis,int port){ //tmbab faili lbi http protokolli, kirjutab selle mlu ning tagastab viida
 soc=new TcpSocket(new InternetAddress(server(mis),port)); 
 ss=new SocketStream(soc);
 ss.writeString("GET "~fail(mis)~" HTTP/1.0\n\n");
 printf("getting: "~"GET "~fail(mis)~" HTTP/1.0\n\n");
 char mach[4];
 mach[0]=13;
 mach[1]='\n';
 mach[2]=13;
 mach[3]='\n';
 
 ubyte []MM=new ubyte[1000_000];
 MM.length=ss.readBlock(cast(char *)MM,1000_000);
 for(int x=0;x<MM.length;x++){
   if(cast(char [])MM[x..x+1]=="\n\n" ){
     return MM[x+2..MM.length];
   }
   if(cast(char [])MM[x..x+4]==mach){
     return MM[x+4..MM.length];
   }
 }
 return MM;
}



int findone(char []s,char sub[][]){ //on olemas find(char []millest,char mis[]), see ttab, kui tahame leida stringi esimest esinemispaika.  Aga kui meil on mitu stringi ja me tahame leida kskik millise nendest esimest esinemispaika, siis kasutama minu funktsiooni.
int a[]=new int[sub.length];
for(int x=0;x<sub.length;x++){
 a[x]=find(s,sub[x]);
 if(a[x]==-1)a[x]=1000_000_000;
}
a=a.sort;
if(a[0]==1000_000_000)return -1000_000_000;
return a[0]; //Tagastab suure negatiivse arvu, kui ei leidunud, vi siis mne positiivse arvu leidumiskohaga
}



int Port; //Serveri port millesse hendada
char []Valjund; //failinimi, kuhu zip fail kirjutada

char pildid[3][];//piltide laiendid .png .gif .jpg


char []getnimi(char []s){ //Eraldab stringist faili osa, ILMA KATALOOGITA, niteks http://ww.neti.ee/pages/3.htm >>> 3.htm  (vrdle fail())
 if(s[s.length-1]=='/')s.length=s.length-1;
for(int x=s.length-1;x>=0;x--){
 if(s[x]=='/'){
   return s[x+1..s.length];
 }
}
return s;
}


int main(char [][]par){
 pildid[0]=".gif";
 pildid[1]=".png";
 pildid[2]=".jpg";
 
 ZA=new ZipArchive(); //Loome uue thja zip arhiivi, kuhu hiljem faile lisada
 
 
 
 if(par.length<3){printf("kasutatakse: httpzip www.leht.ee port failinimi\n");return 0;} //ei antud piisavalt parameetreid
 if(par.length<4)Port=80; //inimene vib ka pordi kirjutamata jtta, selles juhu kasutatakse porti 80
 else Port=toInt(par[2]);
 
 if(par.length<4)Valjund=par[2];
 else Valjund=par[3];
 
 
 
 
 char []HTMLFAIL=cast(char [])tomba(par[1],Port); //Tmbame html faili

 tombapildid(HTMLFAIL,ZA,par); //Tmba pildid, lisa need zip arhiivi ja tee muudatused html failis, nii et see pildid kohalikust kaustast leiaks
 
 
 //Viimaks lisame ka html faili arhiivi
 
 ArchiveMember am=new ArchiveMember();//Loome uue ArchiveMember objekti
 am.name="index.htm"; //faili nimi
 am.expandedData=cast(ubyte [])HTMLFAIL; //faili sisu;
 
 ZA.addMember(am);//Lisame selle objekti arhiivi
 
 void []andmed=ZA.build(); //pakime arviivi kokku. andmed on nd viit mluvljale, kus asub zip arhiiv pakitud kujul
 if(find(Valjund,".zip")==-1)write(Valjund~".zip",andmed); //kirjutame arhiivi diskile, hoolitseme, et faili laiendiks saaks zip (kui see juba ei ole)
 else write(Valjund,andmed); //Faili lained on juba zip.
 return 0;
}






void tombapildid(inout char []ss,inout ZipArchive ZA,char [][]par){
int koht=0;
while(koht>=0){
int j;
 printf("%d\n",ss.length);
 j=findone(ss[(koht+1)..ss.length],pildid);
 koht=koht+j+1;
 printf(">%d\n",koht);
 if(koht>=0){
   int koht2=koht;
   for(int y=koht;y>=0;y--){
     if(ss[y]==' ' || ss[y]=='"' || ss[y]=='=' || ss[y]=='\n'){
       koht2=y+1;
       break;
     }
   }
   ubyte []O;
   
   char nimi[]=getnimi(ss[koht2..koht+1+3]);

  if(OLEMAS[nimi]!=1){
    OLEMAS[nimi]=1;
    printf("%.*s\n",server(par[1])~ss[koht2..koht+1+3]);   
    if(ss[koht2+3]==':') O=tomba(ss[koht2..koht+1+3],Port);
    else {
     if(ss[koht2]!='/')O=tomba(server(par[1])~"/"~ss[koht2..koht+1+3],Port);
     else O=tomba(server(par[1])~ss[koht2..koht+1+3],Port);
    }  
    ArchiveMember am=new ArchiveMember();
    am.name=nimi;
    am.expandedData=O;
    am.compressionMethod=8;
    ZA.addMember(am);
    //write("failid/"~nimi,O);
    
  } 
  ss=ss[0..koht2]~nimi~ss[koht+1+3..ss.length];
  koht=koht2+nimi.length;      
 }
} 
}











