//@Author: Martin Laak.  http://www.arvutilaat.net/D/    Kasutage seda koodi nagu tahate, ainult jtke alles viide minu nimele ja lehele. Use this code however you like, but keep the reference to my name and page,   
//KLASSIDE JA LIIDESTEe KASUTUS, PRILUS, PROPERTY-d


interface inter_face{ // D (nagu Javagi) ei luba multiple inheritance-i, nii et tuleb kasutada liideseid (interface) selle asemel
 public:
  int funktsioon();
}



class alusklass{ //klass, mida hakkan prast laiendama.
 private:
  int val;
 public:
  void set(int v){
     val=v;
  }
  int get(){
     return val;
  }
  
  this(){
   val=-1;
  }
  
  this(int algvaartus){
   val=algvaartus;
  }  
}



class klass1:alusklass{   //klass 'klass1' laiendab klassi 'alusklass'. See on tpselt nagu keeles C++.  Java analoog "class klass1 extends alusklass"
 public:
  this(){                                   //constructor
    printf("Siin synnib uus klassi isend\n"); //kuna siin pole kuskil ilmutatud kujul prdumist lemklassi konstruktori poole, siis lisatakse see antud konstruktori algusesse. Nii, et super() kutsutakse vlja enne selle konstruktori sisu(body) titmist.
  }
  this(int algvaartus){
    super(algvaartus);// kutsume vlja lemklassi konstruktori. Kuna kasutame ilmutatud kujul lemklassi konstruktorit, siis default konstruktorit enam ei lisata.
    printf("Siin synnib uus klassi isend v22rtusega %d\n",algvaartus);
  }
  
  
  //loome property value, selgitus l6pus
  int value(int v){
   set(v);
   return v;
  }
  
  int value(){
   return get();
  }
}


class klass2:klass1,inter_face{ // Java analoog: class algklass extends klass1 implements inter_face
 public:
  this(){}
  this(int val){
    super(val);
  }
  int funktsioon(){ // prit liidesest (interface) 'inter_face', tuleb igal juhul implementeerida, kui implementeerime liidest 'inter_face' 
   printf("Funktsioon on implementeeritud\n");
   return 0;
  }  
}



klass2 k;

//property-d: vaadake lpust
int main(){
k=new klass2(55); 
printf("Vrtus on hetkel  %d\n",k.value);
k.value=k.value+1;
printf("Vrtus on nyyd  %d\n",k.value);
k.value=12;
printf("Vrtus on nyyd  %d\n",k.value);
k.funktsioon();
return 0;
}



/*
Property-d
Vaadake ka suhtle.d

Kui deklareerida 2 samanimelist funktsiooni,
 int fu(int val);
 int fu();
 
 siis 
  fu=5; // on sama mis fu(5);
  a=fu; // on sama mis a=fu();
  a=fu=5 // on sama mis a=fu(5)
 
 
 Samamoodi ka:
 
 char []fu(char []val);
 char []fu();
 
 
 nb! Kui
   int fu(int val){
    ....
    return val; // SIIS SEE, sest a=fu=9; on a=fu(9); ja a peab siis lpuks vrduma 9-ga
   }    
   


*/
